﻿//CustomClass Template - Created by CodenameGamma
//Replace Layout with the CC name, 
//and WoWClass.Mage with the Class your Designing for.
//Created July, 3rd 2010
//For use with Honorbuddy
using System;
using System.Linq;
using System.Collections.Generic;
using System.Collections;
using System.Diagnostics;
using System.Threading;
using System.Text;

using Styx;
using Styx.Combat.CombatRoutine;
using Styx.Helpers;
using Styx.Logic;
using Styx.Logic.Combat;
using Styx.Logic.Pathing;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

using TreeSharp;
using Action = TreeSharp.Action;

namespace Gladiatore
{
    public partial class Warrior : CombatRoutine
    {
        public override sealed string Name { get { return "Gladiatore V3.1"; } }

        public override WoWClass Class { get { return WoWClass.Warrior; } }

        private static LocalPlayer Me { get { return ObjectManager.Me; } }

        public GladiatoreSettings Settings { get; set; }
        public static Warrior Instance { get; set; }

        private void slog(string msg, params object[] args) //use for slogging
        {
            Logging.Write(System.Drawing.Color.SaddleBrown, "Gladiatore: " + msg, args);
        }

        public override bool WantButton
        {
            get
            {
                return true;
            }
        }

        public override void OnButtonPress()
        {
            GladiatoreGui m_config = new GladiatoreGui();
            m_config.Show();
        }

        public Warrior()
        {
            Instance = this;
            Settings = new GladiatoreSettings();
        }

        //Misc Abilities
        public static WoWSpell HS = WoWSpell.FromId(78);
        public static WoWSpell VR = WoWSpell.FromId(34428);
        public static WoWSpell Exe = WoWSpell.FromId(5308);
        public static WoWSpell BShout = WoWSpell.FromId(6673);
        public static WoWSpell CShout = WoWSpell.FromId(469);
        public static WoWSpell DShout = WoWSpell.FromId(1160);
        public static WoWSpell BStance = WoWSpell.FromId(2457);
        public static WoWSpell DStance = WoWSpell.FromId(71);
        public static WoWSpell WRST = WoWSpell.FromId(20549);
        public static WoWSpell Pummel = WoWSpell.FromId(6552);
        public static WoWSpell CL = WoWSpell.FromId(845);
        public static WoWSpell SL = WoWSpell.FromId(1464);
        public static WoWSpell HAM = WoWSpell.FromId(1715);
        public static WoWSpell BR = WoWSpell.FromId(18499);
        public static WoWSpell ER = WoWSpell.FromId(55694);
        public static WoWSpell HL = WoWSpell.FromId(6544);
        public static WoWSpell Charge = WoWSpell.FromId(100);
        public static WoWSpell Inter = WoWSpell.FromId(20252);
        
        //Fury Abilities
        public static WoWSpell BT = WoWSpell.FromId(23881);
        public static WoWSpell RB = WoWSpell.FromId(85288);
        public static WoWSpell WW = WoWSpell.FromId(1680);
        public static WoWSpell DW = WoWSpell.FromId(12292);
        public static WoWSpell Reck = WoWSpell.FromId(1719);
        public static WoWSpell HF = WoWSpell.FromId(60970);
        public static WoWSpell BZStance = WoWSpell.FromId(2458);

        //Arms Abilities
        public static WoWSpell Rend = WoWSpell.FromId(772);
        public static WoWSpell CS = WoWSpell.FromId(86346);
        public static WoWSpell OP = WoWSpell.FromId(7384);
        public static WoWSpell MS = WoWSpell.FromId(12294);
        public static WoWSpell SS = WoWSpell.FromId(12328);
        public static WoWSpell BS = WoWSpell.FromId(46924);
        public static WoWSpell TD = WoWSpell.FromId(85388);
        public static WoWSpell DC = WoWSpell.FromId(85730);

        //Protection Abilities
        public static WoWSpell TC = WoWSpell.FromId(6343);
        public static WoWSpell Deva = WoWSpell.FromId(20243);
        public static WoWSpell SHSL = WoWSpell.FromId(23922);
        public static WoWSpell Rev = WoWSpell.FromId(6572);
        public static WoWSpell SW = WoWSpell.FromId(46968);
        public static WoWSpell SA = WoWSpell.FromId(7386);
        public static WoWSpell SB = WoWSpell.FromId(2565);
        public static WoWSpell SHW = WoWSpell.FromId(871);
        public static WoWSpell LS = WoWSpell.FromId(12975);
        public static WoWSpell SR = WoWSpell.FromId(23920);
        public static WoWSpell CB = WoWSpell.FromId(12809);
        public static WoWSpell SBa = WoWSpell.FromId(72);

        #region Add Detection
        //Credit to CodeNameGamma for detectAdds code
        private List<WoWUnit> adds = new List<WoWUnit>();

        private List<WoWUnit> detectAdds()
        {
            List<WoWUnit> addList = ObjectManager.GetObjectsOfType<WoWUnit>(false).FindAll(unit =>
                        unit.Guid != Me.Guid &&
                        unit.Distance < 12.00 &&
                        (unit.IsTargetingMyPartyMember || unit.IsTargetingMyRaidMember || unit.IsTargetingMeOrPet) &&
                        !unit.IsFriendly &&
                        !unit.IsPet &&
                        !unit.HasAura("Polymorph") &&
                        !unit.HasAura("Hex") &&
                        !unit.HasAura("Fear") &&
                        !unit.HasAura("Sap") &&
                        !unit.HasAura("Bind Elemental") &&
                        !Styx.Logic.Blacklist.Contains(unit.Guid));
            return addList;
        }
        #endregion

        #region Castspell Method
        // Credit to Apoc for the below CastSpell code
        // Used for calling CastSpell in the Combat Rotation
        public bool CastSpell(WoWSpell m_spell)
        {
                        //if we are in the define range
            if (SpellManager.CanCast(m_spell))
            {
                SpellManager.Cast(m_spell);
                // We managed to cast the spell, so return true, saying we were able to cast it.
                slog(m_spell.Name);
                return true;
            }
            // Can't cast the spell right now, so return false.
            return false;
        }
        #endregion

        #region Battle Shout
        public bool BattleShout()
        {
            if (Me.Combat && !Me.Auras.ContainsKey("Battle Shout") && !Me.Mounted && !Warrior.Instance.Settings.UseCShout)
            {
                CastSpell(BShout);
                return true;
            }
            return false;
        }
        #endregion

        #region Commanding Shout
        public bool CommandShout()
        {
            if (Me.Combat && !Me.Auras.ContainsKey("Commanding Shout") && !Me.Mounted && Warrior.Instance.Settings.UseCShout)
            {
                CastSpell(CShout);
                return true;
            }
            return false;
        }
        #endregion

        #region Combat Rotation

        private void AutoAttack()
        {
            if (Me.Combat && !Me.IsAutoAttacking)
            {
                Lua.DoString("StartAttack()");
            }
        }

        public override void Combat()
        {
            if (Me.Dead || Me.Mounted || Me.CurrentTarget == null)
            {
                return;
            }
            
            //Check if we have the aoe green zone under the cursor. A little function to "pause" the combat logic.
            if (Warrior.Instance.Settings.PauseOnPendingAOE)
            {
                if (Me.HasPendingSpell(HL))
                {
                    slog("Heroic Leap pending. Logic paused for 1 second.");
                    Thread.Sleep(1000);
                    return;
                }
            }

            if (Warrior.Instance.Settings.UseFury)
                PerformFuryCombat();
            else if (Warrior.Instance.Settings.UseArms)
                PerformArmsCombat();
            else if (Warrior.Instance.Settings.UseProt)
                PerformProtCombat();
        }
        #endregion

        #region EnhAurasCheck
        private int EnhHasAura(WoWSpell m_spell, WoWUnit unit)
        {
            if (unit.HasAura(m_spell.Name))
            {
                var auras = unit.GetAllAuras();
                foreach (var a in auras)
                {
                    if (a.Name == m_spell.Name && a.CreatorGuid == Me.Guid)
                    {
                        return a.TimeLeft.Seconds;
                    }
                }
            }
            return 0;
        }
        #endregion
    }
}