﻿using System;
using System.Collections.Generic;
using System.Threading;
using CommonBehaviors.Actions;
using Styx;
using Styx.Logic;
using Styx.Logic.Combat;
using Styx.Logic.Pathing;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using TreeSharp;
using Sequence = TreeSharp.Sequence;
using System.Linq;
using Action = TreeSharp.Action;

namespace Gladiatore
{
    partial class Warrior
    {
        void PerformArmsCombat()
        {
            if (Me.Combat)
            {
                if (Warrior.Instance.Settings.UseArms && (Me.CurrentTarget.Distance < Warrior.Instance.Settings.MaxDistance))
                {
                    //Cast Battle Stance if we are in combat
                    if (Me.Combat && !Me.HasAura("Battle Stance"))
                    {
                        CastSpell(BStance);
                    }

                    if (Me.CurrentTarget.IsPlayer && Me.CurrentTarget.Distance > 9)
                    {
                        if (!CastSpell(Charge) && !Me.CurrentTarget.HasAura("Charge"))
                        {
                            if (!CastSpell(Inter) && !Me.CurrentTarget.HasAura("Intercept"))
                            {
                                SpellManager.Cast("Heroic Leap");
                                LegacySpellManager.ClickRemoteLocation(Me.CurrentTarget.Location);
                            }
                        }
                    }

                    if (Me.CurrentTarget != null & Me.Combat)
                    {
                        Lua.DoString("StartAttack()");
                    }

                    if (Warrior.Instance.Settings.UseEnrage && Me.HealthPercent <= 50)
                    {
                        CastSpell(ER);
                    }

                    if (Me.Combat && (Me.HealthPercent < 90))
                    {
                        CastSpell(VR);
                    }

                    if (Me.Combat && Me.CurrentRage <= 50 && !Me.Mounted && !Warrior.Instance.Settings.UseCShout)
                    {
                        CastSpell(BShout);
                    }
                    else if (Me.Combat && Me.CurrentRage <= 50 && !Me.Mounted && Warrior.Instance.Settings.UseCShout)
                    {
                        CastSpell(CShout);
                    }

                    if (Warrior.Instance.Settings.UseDShout && (!Me.CurrentTarget.HasAura("Demoralizing Shout") || Me.CurrentTarget.ActiveAuras["Demoralizing Shout"].Duration < 3))
                    {
                        if (Me.CurrentTarget.Distance < 8)
                        {
                            CastSpell(DShout);
                        }
                    }

                    if (Me.CurrentTarget != null)
                    {
                        if (Me.CurrentTarget.MaxHealth > 1000000 && (Me.CurrentTarget.HealthPercent < 95) && Warrior.Instance.Settings.UseCooldowns)
                        {
                            CastSpell(DC);
                        }

                        if (Me.CurrentTarget.IsCasting && (Me.CurrentTarget.Name != "Maloriak" && (Warrior.Instance.Settings.UsePummel)))
                        {
                            CastSpell(WRST);
                        }

                        if (!Me.CurrentTarget.ActiveAuras.ContainsKey("Sunder Armor"))
                        {
                            CastSpell(SA);
                        }

                        //Execute call!
                        if (Me.CurrentTarget.HealthPercent <= 20)
                        {
                            if (!CastSpell(CS))
                            {
                                if (Me.CurrentRage > 30)
                                {
                                    CastSpell(Exe);
                                }
                            }
                            return;
                        }

                        if (Me.Combat && (EnhHasAura(Rend, Me.CurrentTarget) < 1))
                        {
                            CastSpell(Rend);
                        }

                        if (!Me.CurrentTarget.HasAura("Colossus Smash"))
                        {
                            CastSpell(CS);
                        }

                        if (!CastSpell(OP))
                        {
                            if (!CastSpell(MS) && EnhHasAura(MS, Me.CurrentTarget) > 6)
                            {
                                CastSpell(SL);
                            }
                        }

                        if (Me.CurrentRage >= 70)
                        {
                            CastSpell(HS);
                        }

                        if (Me.Combat && Warrior.Instance.Settings.UseAoE)
                        {
                            adds = detectAdds();
                            {
                                if (adds.Count > 1)
                                {
                                    if (!CastSpell(SS) && !Me.HasAura("Sweeping Strikes"))
                                    {
                                        CastSpell(BS);
                                    }
                                }
                            }
                        }
                        else
                        {
                            return;
                        }
                    }
                    return;
                }
            }
        }
    }
}
